<?php
// wcf imports
require_once(WCF_DIR.'lib/system/template/TemplatePluginModifier.class.php');
require_once(WCF_DIR.'lib/system/template/Template.class.php');

/**
 * The 'htmltruncate' modifier truncates a HTML string.
 * 
 * Usage:
 * {$foo|truncatehtml:35:true:'...'}
 *
 * @package		com.woltlab.community.htmlutility
 * @author		Oliver Kliebisch
 * @copyright	2009 WoltLab Community
 * @license		GNU Lesser Public License <http://www.gnu.org/licenses/lgpl.html>
 * @subpackage	util
 * @category	WCF
 */
class TemplatePluginModifierTruncatehtml implements TemplatePluginModifier {
	/**
	 * @see TemplatePluginModifier::execute()
	 */
	public function execute($tagArgs, Template $tplObj) {				
		// default values
		$length = 500;
		$wordWrap = true;
		$ending = '...';
		$endingPosition = 'after';
		
		// get values
		$string = $tagArgs[0];
		if (isset($tagArgs[1])) $length = intval($tagArgs[1]);
		if (isset($tagArgs[2])) $wordWrap = $tagArgs[2];
		if (isset($tagArgs[3])) $ending = $tagArgs[3];
		if (isset($tagArgs[4])) $endingPosition = $tagArgs[3];
		
		// execute plugin
		if ($length == 0) {
			return '';
		}

		return HTMLUtil::truncateHTML($string, $length, $wordWrap, $ending, $endingPosition);
	}
}
?>